package com.cnbm.generator.build;

import com.baomidou.mybatisplus.generator.FastAutoGenerator;
import com.baomidou.mybatisplus.generator.config.*;
import com.baomidou.mybatisplus.generator.config.builder.ConfigBuilder;
import com.baomidou.mybatisplus.generator.config.po.TableInfo;
import com.baomidou.mybatisplus.generator.engine.FreemarkerTemplateEngine;
import com.baomidou.mybatisplus.generator.engine.VelocityTemplateEngine;
import com.baomidou.mybatisplus.generator.function.ConverterFileName;
import com.cnbm.generator.config.DataConfig;
import com.cnbm.generator.engine.EnhanceVelocityTemplateEngine;
import com.cnbm.generator.utils.IdWorker;
import org.jetbrains.annotations.NotNull;
import org.junit.jupiter.api.Test;

import java.io.File;
import java.util.*;
import java.util.function.BiConsumer;

import static com.baomidou.mybatisplus.generator.config.ConstVal.MODULE_NAME;

/**
 * @Author weihongyang
 * @Date 2022/6/14 8:47 AM
 * @Version 1.0
 */
public class CodeGenerator {


    @Test
    public void test(){
        mybatisPlusGenerator(new String[]{"sys_user","sys_role"});
    }

    public static void mybatisPlusGenerator(String[] include){
        File file = new File("");
        String path = file.getAbsolutePath();
        Map<String, String> customFile = new HashMap<>();
        customFile.put("DTO","/templates/DTO.java.vm");
        customFile.put("Excel","/templates/Excel.java.vm");
        customFile.put("mysql","/templates/mysql.vm");


        FastAutoGenerator.create(DataConfig.url,DataConfig.username,DataConfig.password)
                .globalConfig(builder -> {
                    builder.author("why")
                            .enableSwagger()
                            .fileOverride()
                            .outputDir(path+"/src/main/java");
                })
                .packageConfig(builder -> {
                    //设置父包名
                    builder.parent("com.cnbm.generator")
                            .moduleName("code")
                            .service("service")
                            .serviceImpl("service.impl")
                            .entity("entity")
                            .mapper("mapper")
                            .controller("controller")
                            .xml("mapper");
                })
                .strategyConfig(builder -> {
                    //设置需要生成的表名
                    builder.addInclude(include)
                            //设置过滤表前缀
                            .addTablePrefix("sys_");
                })
                .injectionConfig(consumer -> {

                    consumer.customFile(customFile);
                })
                .templateEngine(new EnhanceVelocityTemplateEngine())
                .execute();
    }

}
